<?php

namespace AMZcockpitDoctrine\Repository\MWS;

use AMZcockpitDoctrine\Entity\User;

/**
 * FeedbackRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class FeedbackRepository extends \Doctrine\ORM\EntityRepository
{

    public function getFeedbackByUser(User $user) {

        $qb = $this->createQueryBuilder('r')
            ->leftJoin('r.store','s');
        $qb->select('r.rating, COUNT(r.id)')
            ->where($qb->expr()->eq('s.user',':user'))
            ->setParameter('user',$user)
            ->groupBy('r.rating');

        $items = $qb->getQuery()->getResult();
        $colors = [
            1   => '#990000',
            2   => '#C38600',
            3   => '#FCD202',
            4   => '#1FBC77',
            5   => '#1E9D5A'
        ];
        $return = [];
        foreach ($items as $item) {
            $return[] = [
                'rating' => '(Rating '.$item['rating'].')',
                'value'  => $item['1'],
                'color'  => $colors[$item['rating']]
            ];
        }
        return $return;
    }

    public function getReviewsSnapshotPositif(User $user) {
        $return = [];
        $days = [7, 30, 90, 180, 365];
        $i = 0;
        while(isset($days[$i])) {
            $date = (new \DateTime('now'))->sub(new \DateInterval('P'.$days[$i].'D'));
            $qb = $this->createQueryBuilder('r');
            $qb->select('COUNT(r) as reviewsCount');
            $qb->leftJoin('r.store','s')
                ->where('s.user = :user')
                ->setParameter('user', $user);

            $qb->andWhere($qb->expr()->gte('r.date',':date'))->setParameter('date',$date);
            $qb->andWhere($qb->expr()->gt('r.rating',':rating'))->setParameter('rating',3);
            $orderCounts = $qb->getQuery()->getSingleScalarResult();
            $return[$days[$i]] = $orderCounts;
            $i++;
        }
        return $return;
    }

    public function getReviewsSnapshotNegatif(User $user) {
        $return = [];
        $days = [7, 30, 90, 180, 365];
        $i = 0;
        while(isset($days[$i])) {
            $date = (new \DateTime('now'))->sub(new \DateInterval('P'.$days[$i].'D'));
            $qb = $this->createQueryBuilder('r');
            $qb->select('COUNT(r) as reviewsCount');
            $qb->leftJoin('r.store','s')
                ->where('s.user = :user')
                ->setParameter('user', $user);

            $qb->andWhere($qb->expr()->gte('r.date',':date'))->setParameter('date',$date);
            $qb->andWhere($qb->expr()->lte('r.rating',':rating'))->setParameter('rating',3);
            $orderCounts = $qb->getQuery()->getSingleScalarResult();
            $return[$days[$i]] = $orderCounts;
            $i++;
        }
        return $return;
    }
}
